ABSReport = CreateFrame('Frame', "ABSReport", UIParent)
ABSReport.enabled = false
ABSReport.created = false
ABSReport:RegisterEvent("ADDON_LOADED")
ABSReport:RegisterEvent("PLAYER_ENTERING_WORLD")
ABSReport:RegisterEvent("ZONE_CHANGED_NEW_AREA")
SLASH_ABSReport1 = '/absr'
SLASH_ABSReport2 = '/ABSR'

if not ABSRSaves then
	ABSRSaves = { scale = 0, x = 0, y = 0, dim = false }
end

local buttons = {
	--{ x={2,2}, y={-2,-2}, w=32, h=32, tex = "repic28", text="---- Préparez-vous à ramasser !! ----"},
	--{ x={34,34}, y={-2,-194}, w=64, h=32, tex = "aroof.blp", text="---- Toit Alliance ----"},
	--{ x={98,98}, y={-2,-2}, w=32, h=32, tex = "cap28", text="---- Prépare-toi à poser !! ----"},
	--{ x={2,98}, y={-34,-162}, w=32, h=32, tex = "agy.blp", text="---- Cim Alliance ----"},
	--{ x={34,66}, y={-34,-162}, w=32, h=32, tex = "afr.blp", text="---- Socle Alliance ----"},
	--{ x={66,34}, y={-34,-162}, w=32, h=32, tex = "abalc.blp", text="---- Balcon Alliance ----"},
	--{ x={98,2}, y={-34,-162}, w=32, h=32, tex = "aramp.blp", text="---- Pente Alliance ----"},
	--{ x={2,98}, y={-66,-130}, w=32, h=32, tex = "aresto.blp", text="---- Regen Alliance ----"},
	{ x={34,66}, y={-66,-130}, w=32, h=32, tex = "aroof.blp", text="---- Écuries ----"},
	--{ x={66,34}, y={-66,-130}, w=32, h=32, tex = "atun.blp", text="---- Tunnel Alliance ----"},
	--{ x={98,2}, y={-66,-130}, w=32, h=32, tex = "azerk.blp", text="---- Zerk Alliance ----"},
	{ x={18,18}, y={-98,-98}, w=32, h=32, tex = "afence.blp", text="---- Scierie ----"},
	{ x={50,50}, y={-98,-98}, w=32, h=32, tex = "azerk.blp", text="---- Forge ----"},
	{ x={82,82}, y={-98,-98}, w=32, h=32, tex = "atun.blp", text="---- Mine ----"},
	--{ x={2,98}, y={-130,-66}, w=32, h=32, tex = "hzerk.blp", text="---- Zerk Horde ----"},
	--{ x={34,66}, y={-130,-66}, w=32, h=32, tex = "htun.blp", text="---- Tunnel Horde ----"},
	{ x={66,34}, y={-130,-66}, w=32, h=32, tex = "aroof.blp", text="---- Ferme ----"},
	--{ x={98,2}, y={-130,-66}, w=32, h=32, tex = "hresto.blp", text="---- Regen Horde ----"},
	--{ x={2,98}, y={-162,-34}, w=32, h=32, tex = "hramp.blp", text="---- Pente Horde ----"},
	--{ x={34,66}, y={-162,-34}, w=32, h=32, tex = "hbalc.blp", text="---- Balcon Horde ----"},
	--{ x={66,34}, y={-162,-34}, w=32, h=32, tex = "hfr.blp", text="---- Socle Horde ----"},
	--{ x={98,2}, y={-162,-34}, w=32, h=32, tex = "hgy.blp", text="---- Cim Horde ----"},
	--{ x={34,34}, y={-194,-2}, w=64, h=32, tex = "hroof.blp", text="---- Toit Horde ----"},
}
local iconPath = "Interface\\Addons\\ABSReport\\Icons\\"


function Print(arg1)
	DEFAULT_CHAT_FRAME:AddMessage("|cffCC121D ABSR|r "..(arg1 or ""))
end

-- Show the dialog when entering WSG
function ABSReport:OnEvent()
	if event == "ADDON_LOADED" and arg1 == "ABSReport" then
		Print("Loaded")
	elseif event == 'PLAYER_ENTERING_WORLD' or event == 'ZONE_CHANGED_NEW_AREA' then
		if GetRealZoneText() == "Arathi Basin" then
			if ABSReport.created == false then
				ABSReport.create()
			end
			ABSReport.ABSFrame:Show()
			ABSReport.enabled = true
		elseif ABSReport.enabled then
			ABSReport.enabled = false
			ABSReport.ABSFrame:Hide()
		end
	end
end
ABSReport:SetScript("OnEvent", ABSReport.OnEvent)

-- Hanlde slash commands
-- /absr
-- /absr scale <0 - 1>
-- /absr xy <x> <Y>
-- /absr x <x>
-- /absr y <y>
SlashCmdList['ABSReport'] = function (msg)
	local _, _, cmd, args = string.find(msg or "", "([%w%p]+)%s*(.*)$")
	if cmd == "" or cmd == nil then
		if ABSReport.enabled then
			ABSReport.enabled = false
			ABSReport.ABSFrame:Hide()
		else
			if ABSReport.created == false then
				ABSReport.create()
			end
			ABSReport.ABSFrame:Show()
			ABSReport.enabled = true
		end
	elseif cmd == "scale" then
		ABSRSaves.scale = tonumber(args)
		Print("Setting Scale "..args)
		if ABSReport.ABSFrame then
			ABSReport.ABSFrame:SetScale(ABSRSaves.scale)
		end
	elseif cmd == "xy" or cmd == "pos" then
		local x, y = string.find(args,"(.*)%s*(.*)")
		ABSRSaves.x = x or 0
		ABSRSaves.y = y or 0
		ABSReport.ABSFrame:SetPoint("TOPLEFT", nil, "TOPLEFT", ABSRSaves.x, -ABSRSaves.y)
	elseif cmd == "x" then
		ABSRSaves.x = tonumber(args) or 0
		ABSReport.ABSFrame:SetPoint("TOPLEFT", nil, "TOPLEFT", ABSRSaves.x, -ABSRSaves.y)
	elseif cmd == "y" then
		ABSRSaves.y = tonumber(args) or 0
		ABSReport.ABSFrame:SetPoint("TOPLEFT", nil, "TOPLEFT", ABSRSaves.x, -ABSRSaves.y)
	elseif cmd == "dim" then
		if ABSRSaves.dim then
			ABSReport.ABSFrame:SetAlpha(1)
			ABSRSaves.dim = false
		else
			ABSReport.ABSFrame:SetAlpha(0.4)
			ABSRSaves.dim = true
		end
	else
		Print("Unknown command "..cmd)
	end
end

function ABSReport_OnEnter()
	if ABSRSaves.dim then
		ABSReport.ABSFrame:SetAlpha(1)
	end
end

function ABSReport_OnLeave()
	if ABSRSaves.dim then
		ABSReport.ABSFrame:SetAlpha(0.4)
	end
end

-- Create the ABSReport dialog
function ABSReport:create()
	-- Option Frame
	local frame = CreateFrame("Frame", "ABSRFrame")
	local ix

	ABSReport.ABSFrame = frame

	tinsert(UISpecialFrames,"ABSReport")

	if UnitFactionGroup("player") == "Horde" then
		ix = 1
		ABSReport.Language = "Orcish"
	else
		ix = 1
		ABSReport.Language = "Common"
	end

	-- Set scale, size and position
	frame:SetWidth(132)
	frame:SetHeight(228)
	if ABSRSaves.scale > 0 then
		frame:SetScale(ABSRSaves.scale)
	end
	if not (ABSRSaves.x > 0 and ABSRSaves.y > 0) then
		ABSRSaves.x = 400
		ABSRSaves.y = 50
	end

	-- Background on entire frame
	frame:SetPoint("TOPLEFT", nil, "TOPLEFT", ABSRSaves.x, -ABSRSaves.y)
	frame:SetBackdrop( {
	  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
	  edgeFile = "Interface\\Tooltips\\UI-Tooltip-Background",
	  tile = true,
	  tileSize = 32,
	  edgeSize = 2,
	  insets = { left = 2, right = 2, top = 2, bottom = 2 }
	} );
	frame:SetBackdropColor(0, 0, 0, .91)
	frame:SetBackdropBorderColor(0.3, 0.3, 0.3, 1)

	-- Make it moveable
	frame:SetMovable(true)
	frame:EnableMouse(true)
	frame:SetClampedToScreen(false)
	if ABSRSaves.dim then
		frame:SetAlpha(0.4)
	end
	frame:Hide()

	-- Handle drag of window
	frame:SetScript("OnMouseDown", function()
		if arg1 == "LeftButton" and not this.isMoving then
			this:StartMoving();
			this.isMoving = true;
		end
	end)
	frame:SetScript("OnMouseUp", function()
		if arg1 == "LeftButton" and this.isMoving then
			local _,_,_,x,y = this:GetPoint()
			ABSRSaves.x = x
			ABSRSaves.y = -y
			this:StopMovingOrSizing();
			this.isMoving = false;
		end
	end)
	frame:SetScript("OnHide", function()
		if this.isMoving then
			this:StopMovingOrSizing();
			this.isMoving = false;
		end
	end)
	frame:SetScript("OnEnter", ABSReport_OnEnter)
	frame:SetScript("OnLeave", ABSReport_OnLeave)

	-- Create the buttons
	for i,btn in pairs(buttons) do
		local btn_frame = CreateFrame("Button", btn.text, frame)
		btn_frame:SetPoint("TOPLEFT", frame, "TOPLEFT", btn.x[ix], btn.y[ix])
		btn_frame.id = i
		btn_frame:SetWidth(btn.w)
		btn_frame:SetHeight(btn.h)
		-- Handle clicks
		btn_frame:SetScript("OnClick", function()
			--Print(buttons[this.id].text)
			SendChatMessage(buttons[this.id].text ,"Battleground" , ABSReport.Language)
		end)
		btn_frame:SetBackdrop( {
			bgFile = iconPath..btn.tex,
		} );
		btn_frame:SetScript("OnEnter", ABSReport_OnEnter)
		btn_frame:SetScript("OnLeave", ABSReport_OnLeave)
	end
	ABSReport.created = true
end